Skip to main content Skip to footer

Customizing Enter Key Behavior in FlexGrid in Vue

Background:

FlexGrid provides built-in keyboard handling for common spreadsheet-style workflows. By default, pressing Enter exits edit mode and moves the selection to another cell. You can adjust the general Enter behavior with the keyActionEnter property, such as setting it to KeyAction.CycleOut.

However, some Vue applications need conditional Enter key behavior, such as preventing navigation for specific rows, keeping a cell in edit mode until a business rule passes, or allowing Enter navigation only for certain cell values.

Because _KeyboardHandler is an internal implementation detail, it should not be overridden directly. The supported approach is to use the Vue initialized binding to access the FlexGrid control instance, then attach a keydown listener to the grid’s hostElement.

Steps to Complete:

  1. Register the Wijmo Vue Grid components.
  2. Create the FlexGrid data source.
  3. Render the Vue FlexGrid and configure keyActionEnter.
  4. Use the initialized event to access the FlexGrid control.
  5. Add custom Enter key handling with business rules.

Getting Started:

Register the Wijmo Vue Grid components

// main.js
import { createApp } from 'vue';
import App from './App.vue';
import { registerGrid } from '@mescius/wijmo.vue2.grid';
import '@mescius/wijmo.styles/wijmo.css';

const app = createApp(App);

registerGrid(app);

app.mount('#app');
  • This registers Wijmo’s Vue Grid components, including wj-flex-grid and wj-flex-grid-column, so they can be used in Vue templates. The Wijmo CSS import is required for the grid to render correctly.

 

Create the FlexGrid data source

<script setup>
import { CollectionView } from '@mescius/wijmo';

const data = new CollectionView(getData(50));

function getData(count) {
  const countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
  const data = [];

  for (let i = 0; i < count; i++) {
    data.push({
      id: i,
      country: countries[i % countries.length],
      sales: Math.random() * 10000,
      expenses: Math.random() * 5000
    });
  }

  return data;
}
</script>
  • This creates a CollectionView for the grid. FlexGrid can bind directly to arrays, but CollectionView is useful when you want Wijmo’s built-in data management behavior for editing, currency, sorting, and other grid operations.

 

Render the Vue FlexGrid and configure keyActionEnter

<script setup>
import { KeyAction } from '@mescius/wijmo.grid';
</script>

<template>
  <wj-flex-grid
    :itemsSource="data"
    :keyActionEnter="KeyAction.CycleOut"
  >
    <wj-flex-grid-column binding="country" header="Country" />
    <wj-flex-grid-column binding="sales" header="Sales" format="n2" />
    <wj-flex-grid-column binding="expenses" header="Expenses" format="n2" />
  </wj-flex-grid>
</template>
  • The itemsSource binding connects the grid to the data source. The keyActionEnter binding sets the grid’s normal Enter key navigation behavior before any conditional custom logic is applied.

 

Use the initialized event to access the FlexGrid control

<script setup>
function initGrid(grid) {
  // Add custom grid setup here.
}
</script>

<template>
  <wj-flex-grid
    :itemsSource="data"
    :keyActionEnter="KeyAction.CycleOut"
    :initialized="initGrid"
  >
    <wj-flex-grid-column binding="country" header="Country" />
    <wj-flex-grid-column binding="sales" header="Sales" format="n2" />
    <wj-flex-grid-column binding="expenses" header="Expenses" format="n2" />
  </wj-flex-grid>
</template>
  • The initialized binding runs after the Vue wrapper creates the underlying FlexGrid control. The grid parameter is the FlexGrid control instance, so you can access APIs such as hostElement, editRange, selection, and addEventListener.

 

Add custom Enter key handling with business rules

<script setup>
function initGrid(grid) {
  grid.addEventListener(
    grid.hostElement,
    'keydown',
    (e) => {
      if (e.key !== 'Enter') {
        return;
      }

      if (grid.editRange) {
        const item = grid.rows[grid.editRange.row].dataItem;

        if (shouldStayInEditMode(item)) {
          e.preventDefault();
          e.stopImmediatePropagation();
        }
      } else {
        const selection = grid.selection;
        const value = grid.getCellData(selection.row, selection.col, true);

        if (shouldPreventEnterNavigation(value)) {
          e.preventDefault();
        }
      }
    },
    true
  );
}

function shouldStayInEditMode(item) {
  return item?.country === 'US';
}

function shouldPreventEnterNavigation(value) {
  return value === 'UK';
}
</script>
  • This listens for Enter key presses on the grid’s host element. The final true argument makes the listener run during the capture phase, which allows your code to intercept Enter before the grid completes its default keyboard handling.
  • When grid.editRange exists, the grid is currently editing a cell.
  • Calling preventDefault() and stopImmediatePropagation() keeps Enter from ending edit mode. When the grid is not editing, the selected cell value is checked and Enter navigation is prevented only when the custom condition is met.

 

With this approach, you can customize Enter key behavior in Vue without overriding internal FlexGrid classes. Use keyActionEnter for the default navigation pattern, and use a keydown listener on hostElement for conditional business logic.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Customizing Enter Key Behavior in FlexGrid in Angular

Background:

FlexGrid provides built-in keyboard handling for common spreadsheet-style workflows. By default, pressing Enter exits edit mode and moves the selection to another cell. You can adjust the general Enter behavior with the keyActionEnter property, such as setting it to KeyAction.CycleOut.

However, some applications need conditional Enter key behavior, such as preventing navigation for specific rows, keeping a cell in edit mode until a business rule passes, or allowing Enter navigation only for certain cell values.

Because _KeyboardHandler is an internal implementation detail, it should not be overridden directly. The supported approach is to attach a keydown listener to the grid’s hostElement and intercept the Enter key before the grid completes its default handling.

Steps to Complete:

  1. Configure the FlexGrid and optional keyActionEnter behavior.
  2. Use the Angular initialized event to access the FlexGrid instance.
  3. Add a capturing keydown listener to the grid’s hostElement.
  4. Check whether the grid is editing or navigating.
  5. Cancel the default Enter behavior when your business condition requires it.

Getting Started:

Configure the FlexGrid and optional keyActionEnter behavior

First, define the grid data and optionally configure keyActionEnter. The KeyAction.CycleOut setting controls the grid’s normal Enter navigation behavior, while the custom key handler will handle conditional exceptions.

import { Component } from '@angular/core';
import { CollectionView } from '@mescius/wijmo';
import { FlexGrid, KeyAction } from '@mescius/wijmo.grid';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html'
})
export class AppComponent {
  data = new CollectionView(this.getData(50));
  keyActionEnter = KeyAction.CycleOut;

  private getData(count: number): any[] {
    const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
    const data = [];

    for (let i = 0; i < count; i++) {
      data.push({
        id: i,
        country: countries[i % countries.length],
        sales: Math.random() * 10000,
        expenses: Math.random() * 5000
      });
    }

    return data;
  }
}
  • This creates a simple data source and sets keyActionEnter as the default Enter key behavior. The custom logic added in the next steps will only override Enter when specific conditions are met.

 

Use the Angular initialized event to access the FlexGrid instance

Use the Angular initialized event to pass the FlexGrid instance to a setup method.

<wj-flex-grid
  #grid
  [itemsSource]="data"
  [keyActionEnter]="keyActionEnter"
  (initialized)="initGrid(grid)">
</wj-flex-grid>
  • The initialized event is useful when you need to attach behavior that requires direct access to the FlexGrid control instance.

 

Add a capturing keydown listener to the grid’s hostElement

Add a keydown listener to the grid’s hostElement. Pass true as the fourth argument so the listener runs during the capture phase.

initGrid(grid: FlexGrid): void {
  grid.addEventListener(
    grid.hostElement,
    'keydown',
    (e: KeyboardEvent) => {
      if (e.key !== 'Enter') {
        return;
      }

      if (grid.editRange) {
        const item = grid.rows[grid.editRange.row].dataItem;

        if (this.shouldStayInEditMode(item)) {
          e.preventDefault();
          e.stopImmediatePropagation();
        }
      } else {
        const selection = grid.selection;
        const value = grid.getCellData(selection.row, selection.col, true);

        if (this.shouldPreventEnterNavigation(value)) {
          e.preventDefault();
        }
      }
    },
    true
  );
}
  • When grid.editRange has a value, the grid is currently editing a cell. Calling preventDefault() and stopImmediatePropagation() prevents Enter from ending edit mode and stops the grid’s internal Enter handling from continuing.
  • When the grid is not in edit mode, you can inspect the selected cell and prevent the default Enter navigation for specific values.

 

Check whether the grid is editing or navigating

Move your custom conditions into helper methods so the Enter handling remains easy to maintain.

private shouldStayInEditMode(item: any): boolean {
  return item?.country === 'US';
}

private shouldPreventEnterNavigation(value: any): boolean {
  return value === 'UK';
}
  • In this example, pressing Enter while editing a row where country is "US" keeps the cell in edit mode. Pressing Enter while a cell with the display value "UK" is selected prevents the normal Enter navigation.

 

Cancel the default Enter behavior when your business condition requires it

If your requirement is specifically to validate the edited value before committing it, you can also use cellEditEnding. Set cancel and stayInEditMode when the value is invalid.

grid.cellEditEnding.addHandler((s, e) => {
  const editor = s.activeEditor;
  const newValue = editor?.value;

  if (newValue === 'Invalid') {
    e.cancel = true;
    e.stayInEditMode = true;
  }
});
  • This is useful when your rule depends on the value entered by the user, while the keydown approach is useful when you need to intercept the Enter key before the grid performs its default navigation or edit-ending action.

 

With this approach, you can customize Enter key behavior without overriding internal FlexGrid classes. Use keyActionEnter for the default navigation pattern, and use a keydown listener on hostElement for conditional business logic.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Customizing Enter Key Behavior in FlexGrid in React

Background:

FlexGrid provides built-in keyboard handling for common spreadsheet-style workflows. By default, pressing Enter exits edit mode and moves the selection to another cell. You can adjust the general Enter behavior with the keyActionEnter property, such as setting it to KeyAction.CycleOut.

However, some applications need conditional Enter key behavior, such as preventing navigation for specific rows, keeping a cell in edit mode until a business rule passes, or allowing Enter navigation only for certain cell values.

Because _KeyboardHandler is an internal implementation detail, it should not be overridden directly. The supported approach is to attach a keydown listener to the grid’s hostElement after the React FlexGrid component has initialized.

Steps to Complete:

  1. Create the FlexGrid data source.
  2. Render the Wijmo React FlexGrid.
  3. Use the React initialized prop to access the FlexGrid control instance.
  4. Add a capturing keydown listener to the grid’s hostElement.
  5. Cancel the default Enter behavior when your business condition requires it.

Getting Started:

Create the FlexGrid data source

const data = React.useMemo(() => {
  return new CollectionView(getData(50));
}, []);
  • This creates a CollectionView once when the React component mounts. CollectionView gives FlexGrid a Wijmo-aware data source for editing, sorting, and current-item tracking.

 

Render the Wijmo React FlexGrid

<WjGrid.FlexGrid
  itemsSource={data}
  keyActionEnter={KeyAction.CycleOut}
>
  <WjGrid.FlexGridColumn binding="country" header="Country" />
  <WjGrid.FlexGridColumn binding="sales" header="Sales" format="n2" />
  <WjGrid.FlexGridColumn binding="expenses" header="Expenses" format="n2" />
</WjGrid.FlexGrid>
  • This displays the data in a React FlexGrid. The keyActionEnter property defines the grid’s normal Enter key navigation behavior before any custom conditional logic is applied.

 

Use the React initialized prop to access the FlexGrid control instance

const initGrid = React.useCallback((grid) => {
  // Add custom grid setup here.
}, []);

return (
  <WjGrid.FlexGrid
    itemsSource={data}
    keyActionEnter={KeyAction.CycleOut}
    initialized={initGrid}
  />
);
  • The React initialized prop runs after the Wijmo control is created. The grid parameter is the underlying FlexGrid control instance, so you can access APIs such as hostElement, editRange, selection, and addEventListener.

 

Add a capturing keydown listener to the grid’s hostElement

const initGrid = React.useCallback((grid) => {
  grid.addEventListener(
    grid.hostElement,
    'keydown',
    (e) => {
      if (e.key !== 'Enter') {
        return;
      }

      // Custom Enter key logic goes here.
    },
    true
  );
}, []);
  • This listens for Enter key presses on the grid’s host element. The final true argument makes the listener run during the capture phase, which lets your code intercept Enter before the grid completes its default keyboard handling.

 

Cancel the default Enter behavior when your business condition requires it

const initGrid = React.useCallback((grid) => {
  grid.addEventListener(
    grid.hostElement,
    'keydown',
    (e) => {
      if (e.key !== 'Enter') {
        return;
      }

      if (grid.editRange) {
        const item = grid.rows[grid.editRange.row].dataItem;

        if (shouldStayInEditMode(item)) {
          e.preventDefault();
          e.stopImmediatePropagation();
        }
      } else {
        const selection = grid.selection;
        const value = grid.getCellData(selection.row, selection.col, true);

        if (shouldPreventEnterNavigation(value)) {
          e.preventDefault();
        }
      }
    },
    true
  );
}, []);

function shouldStayInEditMode(item) {
  return item?.country === 'US';
}

function shouldPreventEnterNavigation(value) {
  return value === 'UK';
}
  • When grid.editRange exists, the grid is currently editing a cell. In that case, preventDefault() and stopImmediatePropagation() keep Enter from ending edit mode. When the grid is not editing, the selected cell value is checked and Enter navigation is prevented only when the custom condition is met.

 

With this approach, you can customize Enter key behavior in React without overriding internal FlexGrid classes. Use keyActionEnter for the default navigation pattern, and use a keydown listener on hostElement for conditional business logic.

Happy coding!

Andrew Peterson

Technical Engagement Engineer